Imports System.Data.OleDb

Public Class LookupCache
    Private m_Values As New Collection

    ' Load the lookup values.
    Public Sub New(ByVal conn As OleDbConnection, ByVal table_name As String, ByVal name_field As String, ByVal value_field As String)
        ' Open a DataReader to get the data.
        Dim db_command As New OleDbCommand( _
            "SELECT " & name_field & ", " & value_field & _
            " FROM " & table_name, _
            conn)
        Dim data_reader As OleDbDataReader = db_command.ExecuteReader()

        ' Save the values.
        Do While data_reader.Read()
            m_Values.Add(data_reader.GetValue(1), data_reader.GetValue(0).ToString)
        Loop
        data_reader.Close()
        db_command.Dispose()
    End Sub

    ' Return a value.
    Public Function GetValue(ByVal name_value As String) As String
        Return m_Values(name_value).ToString
    End Function
End Class
